<?php
//
// by Razor
// igshat@gawab.com
//

define('NO_LOGIN', 1);
define('NO_XAJAX', 1);

include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/func.log.php');
include_once(dirname(__FILE__).'/../lib/func.curl.php');
include_once(dirname(__FILE__).'/../lib/func.shell.php');

// CHECK KEY_CODE
if(rxFramework::safe_var($_SERVER['argv'][1]) != $DBCONF['key_code']) slog($LANG['_key_code'], SLOG_ERR, 1);

// INIT
set_time_limit($CONF['scripts_timeout']+60);
ignore_user_abort(1);
ob_implicit_flush();
if(!$DBCONF['cron']) slog($LANG['cron']['disabled'], SLOG_WARN, 1);
slog($LANG['cron']['started'], SLOG_SYS);
$stime = time();

// RESET STOP PARAMETER
mysql_query("UPDATE conf SET value=0 WHERE name='stop'") or die(mysql_error());

// TRUNCATE COMMAND LOG
mysql_query("TRUNCATE TABLE cmd") or die(mysql_error());
mysql_query("OPTIMIZE TABLE cmd") or die(mysql_error());






slog($LANG['cron']['prepare_grabber']);

// SEARCH READY URLs
$res = mysql_query("SELECT COUNT(id) FROM urls "
	. " WHERE rate"
	. " AND UNIX_TIMESTAMP() - UNIX_TIMESTAMP(date) > (rate * 60)") or die(mysql_error());
if(!mysql_result($res,0)) slog($LANG['grabber']['empty_urls'], SLOG_MES);
else {
	
	// CLEAR AWAIT
	if($DBCONF['grab_clear_await']) {
		slog($LANG['grabber']['clear_await']);
		mysql_query("DELETE FROM proxy WHERE work = -2") or die(mysql_error());
	}

	// CLEAR UNWORKED
	if($DBCONF['grab_clear_unworked']) {
		slog($LANG['grabber']['clear_unworked']);
		mysql_query("DELETE FROM proxy WHERE work = 0") or die(mysql_error());
	}
	
	// RUN GRABBER
	slog($LANG['cron']['run_grabber']);
	for($i=1; $i<=$DBCONF['grab_proc']; $i++) {
		$repl = array(
	        "#\[path]#i" => $fw->dir.'1/',
	        "#\[php]#i" => $DBCONF['php_path'],
	        "#\[key]#i" => $DBCONF['key_code'],
	        "#\[log]#i" => "grab".$i.".log" );
		$cmd = preg_replace(array_keys($repl), array_values($repl), $CONF['cmd_grab']);
		$out = ex($cmd);
		mysql_query("INSERT INTO cmd SET date=NOW(), cmd='".addslashes($cmd)."', `out`='".addslashes($out)."'") or die(mysql_error());
		if($out !== false) slog("#".$i." - ".$LANG['cron']['cmd_ok'].mysql_insert_id(), SLOG_OK);
		else slog("#".$i." - ".$LANG['cron']['cmd_err'].mysql_insert_id(), SLOG_ERR);
	}
}







slog($LANG['cron']['prepare_checker']);

// PING TEST
if($DBCONF['check_ping']) {
	if(!preg_match("#[^\r\n\s]+#", $DBCONF['security'], $m)) slog($LANG['checker']['empty_security'], SLOG_ERR, 1);
	$ip = $m[0];
	$res = ping($ip, 1);
	slog($LANG['checker']['ping_check'].$res['cmd']);
	if($res['time']===false or $res['time']==-1) slog($LANG['checker']['ping_unworked']."\r\n".$res['out'], SLOG_ERR, 1);
	if($CONF['debug']) {
		if($res['time']===false) slog("Ping: empty answer from OS", SLOG_WARN);
		if($res['time']==-1) slog("Ping: cannot parse OS answer", SLOG_WARN);
	}
}

// INFO URL CHECK
slog($LANG['checker']['info_url_check'].": ".$DBCONF['info_url']);
$res = curlGET($DBCONF['info_url'], 0,0,0,0, $DBCONF['check_timeout'], 0,1);
if(!stristr($res['content'], "REQUEST_INFO_PAGE_4896485_CODE")) slog($LANG['checker']['e_info_url'].$res['error'], SLOG_ERR, 1);

// DELETE DEAD PROXIES
mysql_query("DELETE FROM proxy WHERE errors > ".intval($DBCONF['check_errors'])) or die(mysql_error());
slog($LANG['checker']['delete_dead'].intval($DBCONF['check_errors']).". ".mysql_info());

// RUN CHECKER
slog($LANG['cron']['run_checker']);
for($i=1; $i<=$DBCONF['check_proc']; $i++) {
	$repl = array(
		"#\[path]#i" => $fw->dir.'1/',
		"#\[php]#i" => $DBCONF['php_path'],
		"#\[key]#i" => $DBCONF['key_code'],
		"#\[log]#i" => "check".$i.".log" );
	$cmd = preg_replace(array_keys($repl), array_values($repl), $CONF['cmd_check']);
	$out = ex($cmd);
	mysql_query("INSERT INTO cmd SET date=NOW(), cmd='".addslashes($cmd)."', `out`='".addslashes($out)."'") or die(mysql_error());
	if($out !== false) slog("#".$i." - ".$LANG['cron']['cmd_ok'].mysql_insert_id(), SLOG_OK);
	else slog("#".$i." - ".$LANG['cron']['cmd_err'].mysql_insert_id(), SLOG_ERR);
}






// RUN RECHECK
if($DBCONF['recheck']) {
	slog($LANG['cron']['run_recheck']);
	$repl = array(
		"#\[path]#i" => $fw->dir.'1/',
		"#\[php]#i" => $DBCONF['php_path'],
		"#\[key]#i" => $DBCONF['key_code'],
		"#\[log]#i" => "recheck.log" );
	$cmd = preg_replace(array_keys($repl), array_values($repl), $CONF['cmd_recheck']);
	$out = ex($cmd);
	mysql_query("INSERT INTO cmd SET date=NOW(), cmd='".addslashes($cmd)."', `out`='".addslashes($out)."'") or die(mysql_error());
	if($out !== false) slog($LANG['cron']['cmd_ok'].mysql_insert_id(), SLOG_OK);
	else slog($LANG['cron']['cmd_err'].mysql_insert_id(), SLOG_ERR);
}







// RUN EXPORT
if($DBCONF['export']) {
	slog($LANG['cron']['run_export']);
	$repl = array(
		"#\[path]#i" => $fw->dir.'1/',
		"#\[php]#i" => $DBCONF['php_path'],
		"#\[key]#i" => $DBCONF['key_code'],
		"#\[log]#i" => "export.log" );
	$cmd = preg_replace(array_keys($repl), array_values($repl), $CONF['cmd_export']);
	$out = ex($cmd);
	mysql_query("INSERT INTO cmd SET date=NOW(), cmd='".addslashes($cmd)."', `out`='".addslashes($out)."'") or die(mysql_error());
	if($out !== false) slog($LANG['cron']['cmd_ok'].mysql_insert_id(), SLOG_OK);
	else slog($LANG['cron']['cmd_err'].mysql_insert_id(), SLOG_ERR);
}





slog($LANG['cron']['finished'], SLOG_SYS);
?>
