<?php
//
// by Razor
// igshat@gawab.com
//

define('NO_LOGIN', 1);
define('NO_XAJAX', 1);

include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/func.log.php');
include_once(dirname(__FILE__).'/../lib/func.curl.php');
include_once(dirname(__FILE__).'/../lib/func.shell.php');

// CHECK KEY_CODE
if(rxFramework::safe_var($_SERVER['argv'][1]) != $DBCONF['key_code']) slog($LANG['_key_code'], SLOG_ERR, 1);

// INIT
set_time_limit($CONF['scripts_timeout'] + $DBCONF['check_timeout'] * $CONF['check_portion']);
ignore_user_abort(1);
ob_implicit_flush();
if(!function_exists('curl_exec')) slog($LANG['checker']['e_curl'], SLOG_ERR, 1);
slog($LANG['checker']['started'], SLOG_SYS);
$stime = time();

// LOAD SECURITY PARAMETERS
$security = preg_split("#[\r\n\s]+#", $DBCONF['security'], -1, PREG_SPLIT_NO_EMPTY);
if(empty($security)) slog($LANG['checker']['empty_security'], SLOG_ERR, 1);

// LOOK FOR RECHECK ENABLED
if(!empty($_SERVER['argv'][2]) && $_SERVER['argv'][2]=='recheck')
	 $is_recheck = " AND work=1";
else $is_recheck = "";





while(!is_finish()) {
	
	// GET PROXY PORTION
	mysql_query("BEGIN") or die(mysql_error());
	$proxy_res = mysql_query("SELECT id, host, port, country, country_code FROM proxy "
		. " WHERE UNIX_TIMESTAMP(date_check) < (UNIX_TIMESTAMP()-".intval($DBCONF['check_interval']).")"
		. $is_recheck
		. " ORDER BY date_check LIMIT 0,".intval($CONF['check_portion'])." FOR UPDATE") or die(mysql_error());
	if(mysql_num_rows($proxy_res)) {
		$ids = array();
		while(($proxy = mysql_fetch_assoc($proxy_res)) != false) $ids[] = $proxy['id'];
		mysql_data_seek($proxy_res, 0);
		mysql_query("UPDATE proxy SET date_check=NOW(), work=-1 WHERE id IN(".implode(",",$ids).")") or die(mysql_error());
	}
	mysql_query("COMMIT") or die(mysql_error());
	
	if(mysql_num_rows($proxy_res)) slog($LANG['checker']['portion'].": ".mysql_num_rows($proxy_res));
	else slog($LANG['checker']['empty_proxy'], SLOG_MES, 1);


	//
	// START PROXY CHECKING
	//
	while(($proxy = mysql_fetch_assoc($proxy_res)) != false) {
		$proxy_port = $proxy['host'].":".$proxy['port'];		
		
		// COUNTRY DETERMINE (only if already not determined)
		$country = $proxy['country'];
		$country_code = $proxy['country_code'];
		if(empty($proxy['country']) and empty($proxy['country_code'])) {
			$row = country_determine($proxy['host']);
			if($row) {
				$country = $row['name'];
				$country_code = $row['zone2'];
			}
		}

		// PING
		$pingtime = 0;
		if($DBCONF['check_ping'] && !$is_recheck) {
			$pingtime = ping($proxy['host']);
			if($pingtime==-1) {
				slog($LANG['checker']['ping_fail']." [".$proxy_port."]");
				mysql_query("UPDATE proxy SET "
					. " date_check=NOW(),"
					. " count_check=count_check+1,"
					. " uptime = (count_work * 100) / count_check,"
					. " errors=errors+1,"
					. " work=0,"
					. " country='".addslashes($country)."',"
					. " country_code='".addslashes($country_code)."'"
					. " WHERE id=".intval($proxy['id'])) or die(mysql_error());
				continue; // go to next proxy
			}
			if($CONF['debug'] && $pingtime===false) slog("Ping fail: empty answer from OS. ".$proxy['host'], SLOG_WARN);
		}
		
		// LOAD TEST PAGE THROUGH PROXY
		$res = curlPOST('ptest=proxy_test_post', $DBCONF['info_url'], 'proxy_test_referer', 0, 'ptest=proxy_test_cookie', $proxy_port, $DBCONF['check_timeout'], 0,1);
	    
		// IF UNWORKED
		if(!stristr($res['content'], "REQUEST_INFO_PAGE_4896485_CODE") ) {
	    	slog($LANG['checker']['unworked']." [".$proxy_port."] http_code:".$res['info']['http_code']." ".$res['error']);
			mysql_query("UPDATE proxy SET "
				. " date_check=NOW(),"
				. " count_check=count_check+1,"
				. " uptime = (count_work * 100) / count_check,"
				. " errors=errors+1,"
				. " curl_code=".$res['errno'].","
				. " http_code=".$res['info']['http_code'].","
				. " pingtime=".intval($pingtime).","
				. " contime=".$res['info']['connect_time'].","
				. " time=".$res['info']['total_time'].","
				. " work=0,"
				. " country='".addslashes($country)."',"
				. " country_code='".addslashes($country_code)."'"
				. " WHERE id=".intval($proxy['id'])) or die(mysql_error());
			continue; // go to next proxy
	    }
		slog($LANG['checker']['worked']." [".$proxy_port."]", SLOG_OK);	    
	    	    
		// CBL SEARCH
		$cbl = 0;
		if($DBCONF['check_cbl']) {
			slog('CBL function coming soon...');
		}

		stristr($res['content'], "proxy_test_post") ?	$post = 1 : $post = 0;
		stristr($res['content'], "proxy_test_referer") ? $ref = 1 : $ref = 0;
		stristr($res['content'], "proxy_test_cookie") ? $cookies = 1 : $cookies = 0;
		
		// ANONYMOUS
		$anon = 1;
		foreach($security as $v)
			if(stristr($res['content'], $v)) {$anon=0; break;}
		if($anon) {
			// TEST FOR HIGHT ANONYMITY
			$anon = 2;
			if(preg_match_all("|([^\r\n]+)=([^\r\n]+)|", $res['content'], $m, PREG_SET_ORDER)) {
				foreach($m as $v)
					if($v[1]=='HTTP_X_FORWARDED_FOR'
					or $v[1]=='HTTP_X_FORWARDED'
					or $v[1]=='HTTP_X_COMING_FROM'
					or $v[1]=='HTTP_FORWARDED_FOR'
					or $v[1]=='HTTP_FORWARDED'
					or $v[1]=='HTTP_COMING_FROM'
					or $v[1]=='HTTP_VIA'
					or $v[1]=='HTTP_XROXY_CONNECTION'
					or $v[1]=='HTTP_PROXY_CONNECTION') $anon = 1;
			}
		}
	    
		// UPDATE
		mysql_query("UPDATE proxy SET "
				. " date_check=NOW(),"
				. " count_check=count_check+1,"
				. " count_work=count_work+1,"
				. " uptime = (count_work * 100) / count_check,"
				. " errors=0,"
				. " curl_code=".$res['errno'].","
				. " http_code=".$res['info']['http_code'].","
				. " pingtime=".intval($pingtime).","
				. " contime=".$res['info']['connect_time'].","
				. " time=".$res['info']['total_time'].","
				. " work=1,"
				. " post=".$post.","
				. " ref=".$ref.","
				. " anon=".$anon.","
				. " cookies=".$cookies.","
				. " cbl=".$cbl.","
				. " country='".addslashes($country)."',"
				. " country_code='".addslashes($country_code)."'"
				. " WHERE id=".intval($proxy['id'])) or die(mysql_error());
	}
}
?>